<div class="dialog-header">
  <h2 mat-dialog-title>Sign up</h2>
  <button
    type="button"
    mat-icon-button
    [mat-dialog-close]="true"
    class="close-button"
    tabindex="-1"
  >
    <mat-icon aria-hidden="false" aria-label="Close icon">close</mat-icon>
  </button>
</div>

<mat-dialog-content>
  <form [formGroup]="form" (ngSubmit)="submit()" class="login-form">
    <div class="field-container">
      <div class="field">
        <mat-label class="asterix--after">First Name</mat-label>
        <mat-form-field>
          <input matInput formControlName="firstName" gpNameValidation />
          @if (
            controls["firstName"].touched &&
            controls["firstName"].hasError("required")
          ) {
            <mat-hint class="input-error">First Name Required.</mat-hint>
          }
          @if (
            controls["firstName"].touched &&
            controls["firstName"].hasError("invalidChars")
          ) {
            <mat-hint class="input-error"
              >First Name must contain letters only.</mat-hint
            >
          }
        </mat-form-field>
      </div>
      <div class="field">
        <mat-label class="asterix--after">Last Name</mat-label>
        <mat-form-field>
          <input matInput formControlName="lastName" gpNameValidation />
          @if (
            controls["lastName"].touched &&
            controls["lastName"].hasError("required")
          ) {
            <mat-hint class="input-error">Last Name Required.</mat-hint>
          }
          @if (
            controls["lastName"].touched &&
            controls["lastName"].hasError("invalidChars")
          ) {
            <mat-hint class="input-error"
              >Last Name must contain letters only.</mat-hint
            >
          }
        </mat-form-field>
      </div>
    </div>
    <div class="field">
      <mat-label class="asterix--after">User Name</mat-label>

      <mat-form-field validateUsername>
        <input matInput formControlName="username" gpNameValidation />
        @if (
          controls["username"].touched &&
          controls["username"].hasError("required")
        ) {
          <mat-hint class="input-error">Username Required.</mat-hint>
        }
        @if (
          controls["username"].touched &&
          controls["username"].hasError("invalidChars")
        ) {
          <mat-hint class="input-error"
            >Username must contain letters only.</mat-hint
          >
        }
      </mat-form-field>
    </div>
    <div class="field">
      <mat-label class="asterix--after">Email ID</mat-label>

      <mat-form-field>
        <input matInput formControlName="emailId" gpEmailIdValidation />
        @if (
          controls["emailId"].touched &&
          controls["emailId"].hasError("required")
        ) {
          <mat-hint class="input-error">Email ID Required.</mat-hint>
        }
        @if (
          controls["emailId"].touched &&
          controls["emailId"].hasError("invalidPattern")
        ) {
          <mat-hint class="input-error">Please enter valid Email Id</mat-hint>
        }
      </mat-form-field>
    </div>
    <div class="field">
      <mat-label class="asterix--after">Password</mat-label>
      <mat-form-field>
        <input
          type="password"
          matInput
          formControlName="password"
          [type]="hidePassword ? 'password' : 'text'"
        />
        <mat-icon matPrefix>lock</mat-icon>
        <button
          mat-icon-button
          matSuffix
          (click)="hidePassword = !hidePassword"
          [attr.aria-label]="'Hide password'"
          [attr.aria-pressed]="hidePassword"
        >
          <mat-icon>{{
            hidePassword ? "visibility_off" : "visibility"
          }}</mat-icon>
        </button>

        @if (
          controls["password"].touched &&
          controls["password"].hasError("required")
        ) {
          <mat-hint class="input-error">Password Required.</mat-hint>
        }
        @if (
          controls["password"].touched &&
          controls["password"].hasError("invalidLen")
        ) {
          <mat-hint class="input-error"
            >Password must be at least 8 characters long.</mat-hint
          >
        }
        @if (
          controls["password"].touched &&
          (controls["password"].hasError("isDigit") ||
            controls["password"].hasError("isLowerCaseLetter") ||
            controls["password"].hasError("isUpperCaseLetter") ||
            controls["password"].hasError("isSpecialChar"))
        ) {
          <mat-hint class="input-error">
            Password must contain at least one
            <span *ngIf="controls['password'].hasError('isDigit')">number</span>
            <span *ngIf="controls['password'].hasError('isLowerCaseLetter')"
              ><span *ngIf="controls['password'].hasError('isDigit')">, </span>
              lower case letter</span
            >
            <span *ngIf="controls['password'].hasError('isUpperCaseLetter')"
              ><span
                *ngIf="
                  controls['password'].hasError('isDigit') ||
                  controls['password'].hasError('isLowerCaseLetter')
                "
                >,
              </span>
              upper case letter</span
            >
            <span *ngIf="controls['password'].hasError('isSpecialChar')"
              ><span
                *ngIf="
                  controls['password'].hasError('isDigit') ||
                  controls['password'].hasError('isUpperCaseLetter') ||
                  controls['password'].hasError('isLowerCaseLetter')
                "
                >,
              </span>
              special symbol like * & # </span
            >.
          </mat-hint>
        }
      </mat-form-field>
      <div class="password-note">
        <p>
          Your password must contain at least eight characters, which should
          have at least one upper case and one lower case letter, numbers and
          symbols like, ! # &#64; $ * &.
        </p>
      </div>
    </div>

    <gp-password-strength
      [passwordToCheck]="form.value.password"
      (passwordStrength)="passwordValid($event)"
    ></gp-password-strength>

    <div class="field">
      <mat-label class="asterix--after">Confirm password</mat-label>
      <mat-form-field>
        <input
          type="password"
          matInput
          formControlName="confirmPassword"
          [type]="hideConfirmPassword ? 'password' : 'text'"
          gpMatchingPassword="password"
        />
        <mat-icon matPrefix>lock</mat-icon>

        <button
          mat-icon-button
          matSuffix
          (click)="hideConfirmPassword = !hideConfirmPassword"
          [attr.aria-label]="'Hide confirm password'"
          [attr.aria-pressed]="hideConfirmPassword"
        >
          <mat-icon>{{
            hideConfirmPassword ? "visibility_off" : "visibility"
          }}</mat-icon>
        </button>
        @if (
          controls["confirmPassword"].touched &&
          controls["confirmPassword"].hasError("required")
        ) {
          <mat-hint class="input-error">Confirm Password Required.</mat-hint>
        }
        @if (
          controls["confirmPassword"].touched &&
          controls["password"].touched &&
          controls["confirmPassword"].hasError("notEqual")
        ) {
          <mat-hint class="input-error">Passwords do not match</mat-hint>
        }
      </mat-form-field>
    </div>

    <mat-divider></mat-divider>

    <mat-label>
      <h6>New to Graphene Dev02?</h6>
      <p mat-caption>Sign up now to avail all our services</p>
    </mat-label>

    <button
      class="full-width"
      mat-raised-button
      color="primary"
      [class.spinner]="isLoading"
      [disabled]="!enableSubmit || isLoading"
    >
      Sign Up
    </button>
    <div class="footer-signup">
      <span>Already have an Graphene Dev02 ID?</span>
      <a (click)="openSignInDialog()">Sign In</a>
    </div>
  </form>
</mat-dialog-content>
